# -- coding: utf-8 --
""" Script usado para verificar qualidade dos dados de séries temporais
extraídos.
"""

import sys, re

from db import *
from settings import *


db = SingletonDB()

f = open(EXT_OUTPUT_FILE, 'r')
first_line = f.readline()

all = set(db.top_donator_ids)
extracted = set()
repeated = set()

for l in f.readlines(): # reads remainder lines
    id = int(re.findall(re.compile('^\s*[0-9]*'), l)[0])

    # Find repeated ids
    if id not in extracted:
        extracted.add(id)
    else:
        repeated.add(id)


# print repeated ids
repeated = list(repeated)
if repeated:
    print "Repeated ids > 50" if len(repeated) > 50 else "Repeated ids:", list(repeated)

# print missing ids
missing = list(all - extracted)
if missing:
    print "Missing ids > 50" if len(missing) > 50 else "Missing ids:", list(missing)
