# -- coding: utf-8 --
""" Script usado para extrair séries temporais de hemoglobina e hematócritos dos
doadores de sangue.
"""

import sys
import os
import datetime

import parser
from db import *
from settings import *


db = SingletonDB()

try:
    f = open(EXT_OUTPUT_FILE, 'r')
    first_line = f.readline()
    meta = eval(first_line)
    if not meta == db.meta:
        s = "Settings are different than target file. Fix it or delete '%s', bye!" % EXT_OUTPUT_FILE
        sys.exit(s)

    num_donators = meta['num_donators']
    num_extracted = len(f.readlines()) # reads remainder lines
    if not num_extracted <= num_donators:
        s = "Extracted more than requested! Bye!"
        sys.exit(s)

    # File and settings match, try to continue where it had stopped
    if num_extracted == num_donators: # Job done!
        s = "The extraction is already finished in '%s'. Nothing to do :)" 
        sys.exit(s) # nothing to do
    else: # Continue processing
        f = open(EXT_OUTPUT_FILE, 'a')
except IOError:
    # File does not exists, initialize stuff
    f = open(EXT_OUTPUT_FILE, 'w')
    # first line printing
    f.write(str(db.meta) + "\n")
    num_extracted = 0
    num_donators = db.meta['num_donators']

# Extracts remaining time series and write do output file
for i in xrange(num_extracted, num_donators):
    donator_id = db.top_donator_ids[i]

    d = Donator(donator_id)
    d.extract_time_series()

    # write to the file
    f.write(str(d))

    # progress logging
    progress_str = '\r' + str(i+1) + " / " + str(num_donators)
    sys.stdout.write(progress_str)
    sys.stdout.flush()
    i += 1

f.close()
