# -- coding: utf-8 --
""" Script usado para ler arquivos no formato stpy (saída de extractor.py) e
calcular funções de aproximação para as séries temporais
"""

import sys
import re
import datetime
from db import *


class StpyParser():
    meta = {}

    donator_id_regexp = re.compile('^\s*[0-9]*')
    donations_regexp = re.compile('\[.*\]')
    
    def __init__(self, filepath):
        self.f = open(filepath, 'r')
        first_line = self.f.readline()
        self.meta = eval(first_line)
        
        #self.lines = self.f.readlines()[start:end]

    def close(self):
        self.f.close()

    def donators(self):
        '''Devolve próximo doador não processado'''
        for l in self.f:
            donator_id = int(re.findall(self.donator_id_regexp, l)[0])
            d = Donator(donator_id)
            donations_list = eval(re.findall(self.donations_regexp, l)[0])
            d.set_time_series(donations_list)
            
            yield d
